<?php

 /* Statistiques par période ---------------------------------------------------------
	Nb Pages
	Nb IP
	Nb Images
   par :
	total
	années
	années/mois
	années/mois/jour
	années/mois/heures
 ------------------------------------------------------------------------------------ */
 function stats_by_period($total, $year, $month, $day)
 {
	$returned = array();
	$delta = 0;


	$sql = "count(id) as NbPages, count(distinct IP) as NbIP, count(image_id) as NbImg, count(distinct category_id) as NbCat ";
        $sql_nfomax = ", MaxPages, MaxIP, MaxImg";
	$sql_from = " from ".HISTORY_TABLE." ";
	$sql_where = "";
	$sql_order = "";
	$sql_select = "";
	$sql_group = "";



	if($day!="") 
	{ 
		$sql_select="select hour as Id, ";
		$sql_where=" where year = $year and month = $month and day = $day ";	
		$sql_group=" group by hour ";
		$sql_order=" order by hour asc"; 

		for($i=0;$i<24;$i++) 
		{ $returned[$i] = array("Id" => $i, "NbPages" => 0, "NbIP" => 0, "NbImg" => 0, "NbCat"=>0, "MaxPages" => 0, "MaxIP" => 0, "MaxImg" => 0); }
	}
	elseif($month!="") 
	{ 
		$sql_select="select day as Id, ";
		$sql_where=" where year = $year and month = $month ";
		$sql_group=" group by day ";
		$sql_order=" order by day asc"; 

		$delta = 1;
		$NbDays = strftime('%d', mktime(0,0,0,$month+1,0,$year));
		for($i=0;$i<$NbDays;$i++) 
		{ $returned[$i] = array("Id" => $i+1, "NbPages" => 0, "NbIP" => 0, "NbImg" => 0, "NbCat"=>0, "MaxPages" => 0, "MaxIP" => 0, "MaxImg" => 0); }
	}
	elseif($year!="") 
	{ 
		$sql_select="select month as Id, ";
		$sql_where=" where year = $year ";
		$sql_group=" group by month ";
		$sql_order=" order by month asc "; 

		$delta = 1;
		for($i=0;$i<12;$i++) 
		{ $returned[$i] = array("Id" => $i+1, "NbPages" => 0, "NbIP" => 0, "NbImg" => 0, "NbCat"=>0, "MaxPages" => 0, "MaxIP" => 0, "MaxImg" => 0); }
	}
	elseif($total!="Y") 
	{ 
		$sql_select="select year as Id, ";
		$sql_group=" group by year ";
		$sql_order=" order by year desc"; 
	}
	else { $sql_select="select 'Tout' as Id, "; $sql_nfomax=""; }


	$sql_max=", (select max(n.MaxPages) as MaxPages, max(n.MaxIP) as MaxIP, max(n.MaxImg) as MaxImg 
			from (select count(id) as MaxPages, count(distinct IP) as MaxIP, count(image_id) as MaxImg 
					from ".HISTORY_TABLE.$sql_where.$sql_group.") as n) as n ";	
	$sql=$sql_select.$sql.$sql_nfomax.$sql_from.$sql_max.$sql_where.$sql_group.$sql_order;
	
	$result = pwg_query($sql);

	$i=0;
	while ($row = mysql_fetch_array($result))
	{
		if($year.$month.$day=="")
		{ $returned[$i] = $row; $i++; }
		else
		{ $returned[$row["Id"]-$delta] = $row; }
	}
	
	return($returned);
 }


 /* Statistiques par IP --------------------------------------------------------------
	Nb Pages
	Nb Images
   par : 
	IP
	IP/années
	IP/années/mois
	IP/années/mois/jour
 ------------------------------------------------------------------------------------ */
 function stats_by_ip($year, $month, $day, $nbipperpage, $pagenumber)
 {
	$returned0 = array();

	$sql_select="select SQL_CALC_FOUND_ROWS ";
	$sql = "IP, count(id) as NbPages, count(image_id) as NbImg ";
        $sql_nfomax = ", MaxPages, MaxImg";
	$sql_from = " from ".HISTORY_TABLE." ";
	$sql_where = "";
	$sql_group=" group by IP ";
	$sql_order=" order by NbPages desc"; 
	$sql_limit=" limit ".(($pagenumber-1)* $nbipperpage).", ".$nbipperpage;


	if($day!="") 
	{ 
		$sql_where=" where year = $year and month = $month and day = $day ";	
	}
	elseif($month!="") 
	{ 
		$sql_where=" where year = $year and month = $month ";
	}
	elseif($year!="") 
	{ 
		$sql_where=" where year = $year ";
	}
	else { $sql_nfomax = ""; }


	$sql_max=", (select max(n.MaxPages) as MaxPages, max(n.MaxImg) as MaxImg 
			from (select count(id) as MaxPages, count(image_id) as MaxImg 
					from ".HISTORY_TABLE.$sql_where.$sql_group.") as n) as n ";	
	$sql=$sql_select.$sql.$sql_nfomax.$sql_from.$sql_max.$sql_where.$sql_group.$sql_order.$sql_limit;
	
	$result = pwg_query($sql);
	$sql="select FOUND_ROWS()";

	$i=0;
	while ($row = mysql_fetch_array($result))
	{
		$returned0[$i] = $row; $i++;
	}
	$returned[0] = $returned0;

	$result = pwg_query($sql);
	if($result) { $row = mysql_fetch_array($result); $returned[1] = $row[0]; } else { $returned[1] = -1; }
	
	return($returned);
 }



 /* Statistiques par catégories ------------------------------------------------------
	%Pages
	%Images
   par : 
	Catégories
	Catégories/années
	Catégories/années/mois
	Catégories/années/mois/jour
 ------------------------------------------------------------------------------------ */
 function stats_by_category($year, $month, $day, $nbipperpage, $pagenumber)
 {
	$returned0 = array();
	$delta = 0;

	$sql_select="select SQL_CALC_FOUND_ROWS ";
	$sql = "category_id, ".CATEGORIES_TABLE.".name as IdCat, 
count(phpwebgallery_history.id) as NbPages, MaxPages.somme, 100*(count(phpwebgallery_history.id)/MaxPages.somme) as PctPages,
count(phpwebgallery_history.image_id) as NbImg, MaxImg.somme, 100*(count(phpwebgallery_history.image_id)/MaxImg.somme) as PctImg, phpwebgallery_categories.nb_images as NbImgCat, (count(phpwebgallery_history.image_id)/phpwebgallery_categories.nb_images) as RatioImg, greatest(100*(count(phpwebgallery_history.id)/MaxPages.somme), 100*(count(phpwebgallery_history.image_id)/MaxImg.somme)) as MaxPct ";

	$sql_from = " from ".HISTORY_TABLE." LEFT JOIN ".CATEGORIES_TABLE." ON ".CATEGORIES_TABLE.".id = ".HISTORY_TABLE.".category_id ";
	$sql_where = "";
	$sql_group=" group by category_id ";
	$sql_group2="";
	$sql_order=" order by NbPages desc"; 
	$sql_limit=" limit ".(($pagenumber-1)* $nbipperpage).", ".$nbipperpage;


	if($day!="") 
	{ 
		$sql_where=" where year = $year and month = $month and day = $day ";	
	}
	elseif($month!="") 
	{ 
		$sql_where=" where year = $year and month = $month ";
	}
	elseif($year!="") 
	{ 
		$sql_where=" where year = $year ";
	}
	else { }


	$sql_max=", (select count(id) as somme from ".HISTORY_TABLE.$sql_where.$sql_group2.") as MaxPages,
		    (select count(image_id) as somme from ".HISTORY_TABLE.$sql_where.$sql_group2.") as MaxImg ";

	$sql=$sql_select.$sql.$sql_from.$sql_max.$sql_where.$sql_group.$sql_order.$sql_limit;
	
	$result = pwg_query($sql);
	$sql="select FOUND_ROWS()";

	$i=0;
	while ($row = mysql_fetch_array($result))
	{
		$returned0[$i] = $row; $i++;
	}
	$returned[0] = $returned0;

	$result = pwg_query($sql);
	if($result) { $row = mysql_fetch_array($result); $returned[1] = $row[0]; } else { $returned[1] = -1; }
	
	return($returned);
 }


 /* ------------------------------------------------------------------------------------------
    formate le texte : <a href="$link">$value</a> 
    ------------------------------------------------------------------------------------------ */
 function format_link($value, $link)
 {
   return("<a href='$link'>$value</a>");
 }




 /* ------------------------------------------------------------------------------------------
    génère les stats par période, et les mets en forme dans le template 
    ------------------------------------------------------------------------------------------ */
 function display_stats_by_period($total, $year, $month, $day, $max_width)
 {
	global $template, $pagelink;

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_by_period.tpl');


	/* requete */
	$stats = stats_by_period($total, $year, $month, $day);

	$dir_links = "";
	$a_links=array("global" => $pagelink."&fAStat_all=Y",
			"all" => $pagelink."&fAStat_all=N",
			"year" => $pagelink."&fAStat_all=N&fAStat_year=$year",
			"month" => $pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$ip_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_ip",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=$month&fAStat_day=");

	$cat_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_category",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=$month&fAStat_day=");


	/* onglets */

	make_tabsheet('stats_by_period');
	

	/* libellé de la période + constituation navigation */
	if($day!="") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_hours")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".format_link(l10n("AStat_month_of_year_".$month), $a_links["month"])." / ".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $day, $year)))." $day";
	}
	elseif($month!="") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_days")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".l10n("AStat_month_of_year_".$month);
	}
	elseif($year!="") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_months")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".$year;
	}
	elseif($total!="Y") 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_years")); 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".l10n("AStat_period_label_all");
	}
	else 
	{ 
		$template->assign_var("PERIOD_LABEL", l10n("AStat_period_label_all")); 
		$dir_links = l10n("AStat_period_label_global");
	}	


	/* navigation */
	$template->assign_var("L_STAT_TITLE", $dir_links);
	$template->assign_var("MAX_WIDTH", $max_width+10);
	$template->assign_var("ASTAT_NFO_STAT", l10n("AStat_Nfo_Period"));


	/* tableau de stat */
	for($i=0;$i<count($stats);$i++)
	{
	    if($stats[$i]["MaxPages"] > 0)
		{ 
		  $width_pages = ceil(($stats[$i]["NbPages"] * $max_width) / $stats[$i]["MaxPages"] ); 
		  $width_img = ceil(($stats[$i]["NbImg"] * $max_width) / $stats[$i]["MaxPages"] );
		  $width_ip = ceil(($stats[$i]["NbIP"] * $max_width) / $stats[$i]["MaxPages"] );
		}
		else
		{ 
		  $width_pages = 0; 
		  $width_img = 0;
		  $width_ip = 0;
		}

	
            	if($day!="") 
		{ // si jours sélectionné, heures affichées
			$value=$stats[$i]["Id"];
			$link="";
			$value_ip="";
			$value_cat="";
		}
            	elseif($month!="") 
		{ // si mois sélectionné, jours affichés
			$value = $stats[$i]["Id"]." (".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $stats[$i]["Id"], $year))).")";
			$link=$pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=".$stats[$i]["Id"];
			$value_ip=$ip_links["day"].$stats[$i]["Id"];
			$value_cat=$cat_links["day"].$stats[$i]["Id"];
		}
		elseif($year!="") 
		{ // si année sélectionnée, mois affichés
			$value = l10n("AStat_month_of_year_".$stats[$i]["Id"]);
			$link=$pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=".$stats[$i]["Id"];
			$value_ip=$ip_links["month"].$stats[$i]["Id"];
			$value_cat=$cat_links["month"].$stats[$i]["Id"];
		}
		elseif($total!="Y")
 		{ // si total sélectionné, années affichées
			$value = $stats[$i]["Id"];
			$link=$pagelink."&fAStat_all=N&fAStat_year=".$stats[$i]["Id"];
			$value_ip=$ip_links["year"].$stats[$i]["Id"];
			$value_cat=$cat_links["year"].$stats[$i]["Id"];
		}
		else 
		{ 
			$value=l10n("AStat_period_label_all"); 
			$link=$pagelink."&fAStat_all=N";
			$value_ip=$ip_links["all"];
			$value_cat=$cat_links["all"];
		}


		if((($stats[$i]["NbPages"] + $stats[$i]["NbImg"] + $stats[$i]["NbIP"])>0)&&($link!=""))
		{ $value=format_link($value, $link); }

		if((($stats[$i]["NbIP"])>0)&&($value_ip!=""))
		{ $value_ip=format_link($stats[$i]["NbIP"], $value_ip); }
		else
		{ $value_ip = $stats[$i]["NbIP"]; }

		if((($stats[$i]["NbCat"])>0)&&($value_cat!=""))
		{ $value_cat=format_link($stats[$i]["NbCat"], $value_cat); }
		else
		{ $value_cat= $stats[$i]["NbCat"]; }


	    $template->assign_block_vars(
	      'stat_by_period_row',
	      array(
	        'VALUE' => $value,
	        'PAGES' => $stats[$i]["NbPages"],
	        'PICTURES' => $stats[$i]["NbImg"],
	        'CATEGORIES' => $value_cat,
	        'IPVISIT' => $value_ip,
	        'WIDTH1' => $width_ip,
	        'WIDTH2' => $width_img,
	        'WIDTH3' => $width_pages,
	        )
	      );
	}
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }
 //------------------------------------------------------------------------------------


 /* ------------------------------------------------------------------------------------------
    génère les stats par IP, et les mets en forme dans le template 
    ------------------------------------------------------------------------------------------ */
 function display_stats_by_ip($year, $month, $day, $max_width, $nbipperpage, $pagenumber)
 {
	global $template, $pagelink;

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_by_ip.tpl');


	/* requete */
	$returned = stats_by_ip($year, $month, $day, $nbipperpage, $pagenumber);
	$stats=$returned[0];
	$nbfoundrows=$returned[1];
	$nbpages=ceil($nbfoundrows / $nbipperpage);



	$dir_links = "";
	$page_link = "";
	$a_links=array("global" => $pagelink."&fAStat_all=Y",
			"all" => $pagelink."&fAStat_all=N",
			"year" => $pagelink."&fAStat_all=N&fAStat_year=$year",
			"month" => $pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$ip_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_ip",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_ip&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");


	/* onglets */

	make_tabsheet('stats_by_ip');
	

	/* constitution navigation */
	if($day!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".format_link(l10n("AStat_month_of_year_".$month), $a_links["month"])." / ".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $day, $year)))." $day";
		$page_link=$ip_links["day"];
	}
	elseif($month!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".l10n("AStat_month_of_year_".$month);
		$page_link=$ip_links["month"];
	}
	elseif($year!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".$year;
		$page_link=$ip_links["year"];
	}
	else 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".l10n("AStat_period_label_all");
		$page_link=$ip_links["all"];
	}
	

	if($nbpages>1) { $plural="s"; } else { $plural=""; }
	$pages_links=l10n("AStat_page".$plural."_label")." : ";
	for($i=1;$i<=$nbpages;$i++)
	{
		if($i==$pagenumber) 
		{ $pages_links.=" $i "; } 
		else
		{
			$pages_links.=format_link(" $i ", $page_link."&fAStat_page_number=$i");
		}
	}



	/* navigation */
	$template->assign_var("L_STAT_TITLE", $dir_links);
	$template->assign_var("MAX_WIDTH", $max_width+10);
	$template->assign_var("NB_TOTAL_IP", l10n('AStat_nb_total_ip')." : $nbfoundrows");
	$template->assign_var("PAGES_LINKS", $pages_links);
	$template->assign_var("ASTAT_NFO_STAT", l10n("AStat_Nfo_IP"));


	/* tableau de stat */
	for($i=0;$i<count($stats);$i++)
	{
	    if($stats[$i]["MaxPages"] > 0)
		{ 
		  $width_pages = ceil(($stats[$i]["NbPages"] * $max_width) / $stats[$i]["MaxPages"] ); 
		  $width_img = ceil(($stats[$i]["NbImg"] * $max_width) / $stats[$i]["MaxPages"] );
		}
		else
		{ 
		  $width_pages = 0; 
		  $width_img = 0;
		}



	    $template->assign_block_vars(
	      'stat_by_ip_row',
	      array(
	        'IP' => $stats[$i]["IP"],
	        'PAGES' => $stats[$i]["NbPages"],
	        'PICTURES' => $stats[$i]["NbImg"],
	        'WIDTH1' => $width_img,
	        'WIDTH2' => $width_pages,
	        )
	      );
	}
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }






 /* ------------------------------------------------------------------------------------------
    génère les stats par catégories, et les mets en forme dans le template 
    ------------------------------------------------------------------------------------------ */
 function display_stats_by_category($year, $month, $day, $max_width, $nbipperpage, $pagenumber)
 {
	global $template, $pagelink;

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_by_category.tpl');


	/* requete */
	$returned = stats_by_category($year, $month, $day, $nbipperpage, $pagenumber);
	$stats=$returned[0];
	$nbfoundrows=$returned[1];
	$nbpages=ceil($nbfoundrows / $nbipperpage);



	$dir_links = "";
	$page_link = "";
	$a_links=array("global" => $pagelink."&fAStat_all=Y",
			"all" => $pagelink."&fAStat_all=N",
			"year" => $pagelink."&fAStat_all=N&fAStat_year=$year",
			"month" => $pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_all=N&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");

	$cat_links=array("all" => $pagelink."&fAStat_tabsheet=stats_by_category",
			"year" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year",
			"month" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=$month",
			"day" => $pagelink."&fAStat_tabsheet=stats_by_category&fAStat_year=$year&fAStat_month=$month&fAStat_day=$day");


	/* onglets */

	make_tabsheet('stats_by_category');
	

	/* constitution navigation */
	if($day!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".format_link(l10n("AStat_month_of_year_".$month), $a_links["month"])." / ".l10n("AStat_day_of_week_".date("w",mktime(0, 0, 0, $month, $day, $year)))." $day";
		$page_link=$cat_links["day"];
	}
	elseif($month!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".format_link($year, $a_links["year"])." / ".l10n("AStat_month_of_year_".$month);
		$page_link=$cat_links["month"];
	}
	elseif($year!="") 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".format_link(l10n("AStat_period_label_all"), $a_links["all"])." / ".$year;
		$page_link=$cat_links["year"];
	}
	else 
	{ 
		$dir_links = format_link(l10n("AStat_period_label_global"), $a_links["global"])." / ".l10n("AStat_period_label_all");
		$page_link=$cat_links["all"];
	}
	

	if($nbpages>1) { $plural="s"; } else { $plural=""; }
	$pages_links=l10n("AStat_page".$plural."_label")." : ";
	for($i=1;$i<=$nbpages;$i++)
	{
		if($i==$pagenumber) 
		{ $pages_links.=" $i "; } 
		else
		{
			$pages_links.=format_link(" $i ", $page_link."&fAStat_page_number=$i");
		}
	}


	/* navigation */
	$template->assign_var("L_STAT_TITLE", $dir_links);
	$template->assign_var("MAX_WIDTH", $max_width);
	$template->assign_var("NB_TOTAL_CATEGORY", l10n('AStat_nb_total_category')." : $nbfoundrows");
	$template->assign_var("PAGES_LINKS", $pages_links);
	$template->assign_var("ASTAT_NFO_STAT", l10n("AStat_Nfo_Category"));




	/* tableau de stat */
	for($i=0;$i<count($stats);$i++)
	{
		 $width_pages = ceil(($stats[$i]["PctPages"] * $max_width)/100 ); 
  		  $width_img = ceil(($stats[$i]["PctImg"] * $max_width)/100 );
		


	    $template->assign_block_vars(
	      'stat_by_category_row',
	      array(
	        'CATEGORY' => format_link($stats[$i]["IdCat"], PHPWG_ROOT_PATH."index.php?/category/".$stats[$i]["category_id"]), 
	        'PCTPAGES' => $stats[$i]["PctPages"],
	        'PCTPICTURES' => $stats[$i]["PctImg"],
	        'RATIOPICTURES' => $stats[$i]["RatioImg"],
	        'WIDTH1' => $width_img,
	        'WIDTH2' => $width_pages,
	        )
	      );
	}
	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }




 function do_import()
 {
   global $prefixeTable, $template;

	 $import_ok=false;
	 $import_step=0;
	 $import_log="";
	 $time_dbt = microtime(true);
	 if($_POST['f_AStat_ok_to_import']=='on')
	 {
		$import_step++;
		/* on supprime la table temporaire si elle existe encore */
		$sql="DROP TABLE IF EXISTS AStat_tmp";
		$result=pwg_query($sql);
		if($result)
		{
			$import_step++;
			/* import dans la table temporaire */
			$sql="CREATE TABLE AStat_tmp (KEY iimages (image_id), KEY icategory (category_id))
				SELECT DATE(date) AS date, TIME (date) AS time, YEAR(date) AS year, MONTH(date) AS month, DAY(date) AS day, HOUR(date) AS hour,
				".$prefixeTable."users.id AS user_id, IP, NULL AS section, 
				TRIM(SUBSTRING_INDEX(".$prefixeTable."history_backup.category, '/', -1)) AS category_id, NULL AS tag_ids,
				".$prefixeTable."history_backup.picture AS image_id, 'false' AS summarized,
				IF(".$prefixeTable."history_backup.picture = '', 'other', 'picture') AS image_type
				FROM ".$prefixeTable."history_backup, ".$prefixeTable."users
				WHERE ".$prefixeTable."history_backup.login = ".$prefixeTable."users.username ; ";
			$result=pwg_query($sql);
			if($result)
			{
				$import_step++;
				/* mise à jour des ID pour les images */
				$sql="UPDATE AStat_tmp, ".$prefixeTable."images  SET image_id = ".$prefixeTable."images.id
					WHERE ".$prefixeTable."images.file = AStat_tmp.image_id;";
				$result=pwg_query($sql);
				if($result)
				{
					$import_step++;
					/* mise à NULL des ID pour les images sans nom */
					$sql="UPDATE AStat_tmp SET image_id = NULL WHERE AStat_tmp.image_id = '';";
					$result=pwg_query($sql);
					if($result)
					{
						$import_step++;
						/* mise à 0 des ID pour les catégories sans catégorie */
						$sql="UPDATE AStat_tmp SET category_id = 0 
					WHERE AStat_tmp.category_id NOT IN (SELECT DISTINCT name FROM ".$prefixeTable."categories);";
						$result=pwg_query($sql);
						if($result)
						{
							$import_step++;
							/* mise à JOUR des ID pour les catégories */
							$sql="UPDATE AStat_tmp, ".$prefixeTable."categories SET category_id = ".$prefixeTable."categories.id WHERE AStat_tmp.category_id = ".$prefixeTable."categories.name;";
							$result=pwg_query($sql);
							if($result)
							{
								$import_step++;
								/* import dans la table temporaire des nouveaux historiques */
								/* on force 'summarized' à 'false' */
								$sql="INSERT INTO AStat_tmp (date, time, year, month, day, hour, user_id, IP, section, category_id, tag_ids, image_id, summarized, image_type) SELECT date, time, year, month, day, hour, user_id, IP, section, category_id, tag_ids, image_id, 'false', image_type FROM ".$prefixeTable."history ";
								$result=pwg_query($sql);
								if($result)
								{ 
									$import_step++;
									/* vider la table historique */
									$sql="DELETE FROM ".$prefixeTable."history";
									$result=pwg_query($sql);
									if($result)
									{ 
										$import_step++;
										/* vider la table historique résumé */
										$sql="DELETE FROM ".$prefixeTable."history_summary";
										$result=pwg_query($sql);
										if($result)
										{ 
											$import_step++;
											/* dernière étape : insertion dans HISTORY */
											$sql="INSERT INTO ".$prefixeTable."history (date, time, year, month, day, hour, user_id, IP, section, category_id, tag_ids, image_id, summarized, image_type) SELECT * FROM AStat_tmp ORDER BY date, time;";
											$result=pwg_query($sql);
											if($result)
											{ 
												$import_step++;
												/* import terminé */
												$import_ok=true;
												$sql="SELECT COUNT(*) FROM AStat_tmp;";
												$result=pwg_query($sql);
												$row=mysql_fetch_row($result);	
												$import_log=$row[0]." ".l10n('AStat_log_import1')." ";
												$sql="DROP TABLE IF EXISTS AStat_tmp";
												$result=pwg_query($sql);
												$import_log.=(100*($time_dbt-microtime(true)))."s";
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	 }

	 if(!$import_ok)
	 {
	  if($import_step==0)
	  { $template->assign_var("ASTAT_WARNING_CHECKBOX", "<p class='errors'>".l10n('AStat_warning_checkbox_import')." [$import_step]</p>"); }
	  else
	  { $template->assign_var("ASTAT_WARNING_CHECKBOX", "<p class='errors'>".l10n('AStat_error_import')." [#$import_step]</p>"); }
	 }
	 else
	 {
	  $template->assign_var("ASTAT_IMPORT_OK", "<p class='infos'>".l10n('AStat_import_ok')."<br/>$import_log</p>");
	 } 
	return($import_ok);
 }


 /* ------------------------------------------------------------------------------------------
    génère la page de configuration 
    ------------------------------------------------------------------------------------------ */
 function display_config()
 {
	global $template, $pagelink, $plugin_object;

	$template->assign_var("L_STAT_TITLE", l10n('AStat_config_title'));

        $template->set_filename('body_page', dirname(__FILE__).'/AStat_config.tpl');
	make_tabsheet('config');

	if($plugin_object->my_config['AStat_show_import'] == 'O') { $display='block'; } else { $display='none'; }
	$template->assign_var("ASTAT_SHOW_IMPORT", $display);
	
	if($plugin_object->my_config['AStat_show_import']=='N')
	{ $template->assign_var("ASTAT_NO_IMPORT_TO_SHOW", l10n('AStat_no_import_show')); }

	reset($plugin_object->my_config); 
	while (list($key, $val) = each($plugin_object->my_config)) 
	{ $template->assign_var("f_".$key, $val); }

	$template->assign_var_from_handle('ASTAT_BODY_PAGE', 'body_page');
 }




 /* ------------------------------------------------------------------------------------------
   génère les onglets de la page 
    ------------------------------------------------------------------------------------------ */
 function make_tabsheet($selected_page)
 { //derived from pwg function_tabsheet.inc.php
  global $template, $pagelink;

	  $page['tabsheet'] = array
	  (
	    'stats_by_period' => array
	     (
	      'caption' => l10n('AStat_by_period'),
	      'url' => $pagelink.'&fAStat_tabsheet=stats_by_period',
	      'selected' => ($selected_page=='stats_by_period')	
	     ),
	    'stats_by_ip' => array
	     (
	      'caption' => l10n('AStat_by_ip'),
	      'url' => $pagelink.'&fAStat_tabsheet=stats_by_ip',
	      'selected' => ($selected_page=='stats_by_ip')	
	     ),
	    'stats_by_category' => array
	     (
	      'caption' => l10n('AStat_by_category'),
	      'url' => $pagelink.'&fAStat_tabsheet=stats_by_category',
	      'selected' => ($selected_page=='stats_by_category')
	     ),
	    'config' => array
	     (
	      'caption' => l10n('AStat_config'),
	      'url' => $pagelink.'&fAStat_tabsheet=config',
	      'selected' => ($selected_page=='config')
	     )
	  );


  if (count($page['tabsheet']) > 0)
  {
    $template->set_filename('tabsheet', 'admin/tabsheet.tpl');

    foreach ($page['tabsheet'] as $tab_name => $tab)
    {
      $is_selected = ($tab['selected'] == 1);
      $template->assign_block_vars
      (
        'tab',
        array
        (
          'CLASSNAME' => ($is_selected ? 'selected_tab' : 'normal_tab'),
          'URL' => $tab['url'],
          'CAPTION' => $tab['caption']
        )
      );

      if ($is_selected)
      {
        $template->assign_vars(
          array('TABSHEET_TITLE' => '['.$tab['caption'].']'));
      }
    }

    $template->assign_var_from_handle('TABSHEET', 'tabsheet');
  }
 }







?>
